  using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public static void Main()
        {

            {

                CategoryBuilder.Create("God of War", "God of War Mod - by reteretei", ModAPI.LoadSprite("ic/cat_icon.png"));

                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[GoW1] Kratos -GoW",
                        DescriptionOverride = "Stricken with horror and grief at what he had done, Kratos left the bodies of his family to be burned within the temple, ultimately renouncing his allegiance to the God of War. The oracle cursed Kratos, forcing him to forever wear the ashes of his dead family on his skin.",
                        CategoryOverride = ModAPI.FindCategory("God of War"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/gow1/kratos.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/gow1/kratos.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;

                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ar/gow1/kratos_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }

                        foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow1/kratos_head.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                        }

                    }
                );
                ModAPI.Register(
                      new Modification()
                      {
                          OriginalItem = ModAPI.FindSpawnable("Sword"),
                          NameOverride = "[GoW1] Blades of Chaos (LvL3) -GoW",
                          DescriptionOverride = "No mere sword and shield would befit the newest servant of the God of War.",
                          CategoryOverride = ModAPI.FindCategory("God of War"),
                          ThumbnailOverride = ModAPI.LoadSprite("ic/gow1/chaos.png", 22f),
                          AfterSpawn = (Instance) =>
                          {
                              Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/gow1/blades.png", 3.2f);
                             
                          }
                      }
                  );
                  ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[GoW1] Undead Legionnaire -GoW",
                        DescriptionOverride = "Undead Legionnaires, their sub-types and counterparts (like Hoplites) are the most common enemies in the God of War series, as well as Undead creatures in general.",
                        CategoryOverride = ModAPI.FindCategory("God of War"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/gow1/undead.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/gow1/undead.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;

                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ar/gow1/undead_helmet.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                        }

                    }
                );
                ModAPI.Register(
                      new Modification()
                      {
                          OriginalItem = ModAPI.FindSpawnable("Sword"),
                          NameOverride = "[GoW1] Undead Legionnare's Sword -GoW",
                          DescriptionOverride = "Undead Legionnare's Sword.",
                          CategoryOverride = ModAPI.FindCategory("God of War"),
                          ThumbnailOverride = ModAPI.LoadSprite("ic/gow1/undead_sword.png", 22f),
                          AfterSpawn = (Instance) =>
                          {
                              Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/gow1/undead_sword.png", 1.6f);
                          }
                      }
                  );
                  ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[GoW2, GoW3] Kratos -GoW",
                        DescriptionOverride = "Zeus! Your son has returned, I bring the destruction of Olympus!!!",
                        CategoryOverride = ModAPI.FindCategory("God of War"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/gow2/kratos.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/gow2/kratos.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;

                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ar/gow1/kratos_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }

                        foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow1/kratos_head.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontArm").Find("UpperArmFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow2/kratos_upperarm.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontArm").Find("LowerArmFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow2/kratos_lowerarm.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[GoW2] Kratos in Ares Armor -GoW",
                        DescriptionOverride = "Armor of a true God of War.",
                        CategoryOverride = ModAPI.FindCategory("God of War"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/gow2/kratos.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/gow2/kratos_ares.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;

                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ar/gow1/kratos_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }

                        foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow1/kratos_head.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontArm").Find("UpperArmFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow2/kratos_ares_upperarm.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontArm").Find("LowerArmFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow2/kratos_ares_lowerarm.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                            }
                        }

                    }
                );
                ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[GoW2, GoW3] Zeus -GoW",
                        DescriptionOverride = "We have faced far worse than this one fallen mortal. But we are the gods! We who the mortals worship. We who rule over this land. We who will not be swept aside by this petulant fool! Brothers, put aside the petty grievances that have splintered us for so long. We will unite. We will stand together. And I will wipe out this plague! Olympus...will prevail!",
                        CategoryOverride = ModAPI.FindCategory("God of War"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/gow2/zeus.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/gow2/zeus.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;

                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow2/zeus_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
                            }

                        foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow2/zeus_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontArm").Find("UpperArmFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow2/zeus_upperarm.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontArm").Find("LowerArmFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow2/zeus_lowerarm.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                            }
                        }

                    }
                );
                ModAPI.Register(
                      new Modification()
                      {
                          OriginalItem = ModAPI.FindSpawnable("Sword"),
                          NameOverride = "[GoW2] Blade of Olympus -GoW",
                          DescriptionOverride = "I offer you more than help Kratos; I offer you power! I offer you the Blade of Olympus; it was this blade that ended the Great War and defeated the Titans! Drain your godly powers into the sword Kratos, only then will you reach your full potential.",
                          CategoryOverride = ModAPI.FindCategory("God of War"),
                          ThumbnailOverride = ModAPI.LoadSprite("ic/gow2/bladeofolympus.png", 22f),
                          AfterSpawn = (Instance) =>
                          {
                              Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/gow2/bladeofolympus.png", 1.9f);

                              //add a UseEventTrigger and set its action
                                //Instance.AddComponent<UseEventTrigger>().Action = () => {
                                //spawn an effect by the name of "Spark" at the transform position
                                //ModAPI.CreateParticleEffect("Spark", Instance.transform.position);
                                //};
                          }
                      }
                  );
                  ModAPI.Register(
                      new Modification()
                      {
                          OriginalItem = ModAPI.FindSpawnable("Sword"),
                          NameOverride = "[GoW2] Blades of Athena (LvL5) -GoW",
                          DescriptionOverride = "Powerful blades given to you by the goddess, Athena.",
                          CategoryOverride = ModAPI.FindCategory("God of War"),
                          ThumbnailOverride = ModAPI.LoadSprite("ic/gow2/blades5.png", 22f),
                          AfterSpawn = (Instance) =>
                          {
                              Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/gow2/blades5.png", 3.2f);
                             
                          }
                      }
                  );
                  ModAPI.Register(
                      new Modification()
                      {
                          OriginalItem = ModAPI.FindSpawnable("Sword"),
                          NameOverride = "[GoW1] Blades of Chaos (LvL1) -GoW",
                          DescriptionOverride = "No mere sword and shield would befit the newest servant of the God of War.",
                          CategoryOverride = ModAPI.FindCategory("God of War"),
                          ThumbnailOverride = ModAPI.LoadSprite("ic/gow1/blades1.png", 22f),
                          AfterSpawn = (Instance) =>
                          {
                              Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/gow1/blades1.png", 3.2f);
                             
                          }
                      }
                  );
                  ModAPI.Register(
                      new Modification()
                      {
                          OriginalItem = ModAPI.FindSpawnable("Sword"),
                          NameOverride = "[GoW1] Blades of Chaos (LvL5) -GoW",
                          DescriptionOverride = "No mere sword and shield would befit the newest servant of the God of War.",
                          CategoryOverride = ModAPI.FindCategory("God of War"),
                          ThumbnailOverride = ModAPI.LoadSprite("ic/gow1/blades5.png", 22f),
                          AfterSpawn = (Instance) =>
                          {
                              Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/gow1/blades5.png", 3.2f);
                             
                          }
                      }
                  );
                  ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[GoW4] Kratos -GoW",
                        DescriptionOverride = "We will be the gods we choose to be, not those who have been. Who I was is not who you will be. We must be better.",
                        CategoryOverride = ModAPI.FindCategory("God of War"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/gow4/kratos.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/gow4/kratos.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;

                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow4/kratos_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
                            }

                        foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow4/kratos_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontArm").Find("UpperArmFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow4/kratos_upperarm.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontArm").Find("LowerArmFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow4/kratos_lowerarmfront.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("BackArm").Find("LowerArm"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow4/kratos_lowerarmback.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                            }
                        }

                    }
                );
                ModAPI.Register(
                      new Modification()
                      {
                          OriginalItem = ModAPI.FindSpawnable("Knife"),
                          NameOverride = "[GoW4] Leviathan Axe -GoW",
                          DescriptionOverride = "It was forged by the Huldra Brothers, Sindri and Brok, who also forged Thor's hammer, Mjölnir, after feeling responsible for the destruction brought about by Thor. As a weapon made to oppose the power of Mjölnir and inspired by the epic size of Jörmungandr, Brok suggests the axe be named Leviathan. According to Sindri when first meeting him, the blade was infused with the echoing screams of twenty frost trolls (give or take) and it was made for and given to Laufey who passed it on to her husband Kratos, before her death.",
                          CategoryOverride = ModAPI.FindCategory("God of War"),
                          ThumbnailOverride = ModAPI.LoadSprite("ic/gow4/axe.png", 22f),
                          AfterSpawn = (Instance) =>
                          {
                              Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/gow4/leviathan.png", 3f);
                                Instance.FixColliders();
                             
                          }
                      }
                  );
                  ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[GoW4] Atreus -GoW",
                        DescriptionOverride = "That was your father in Hel... Is this what it is to be a god? Is this how it always ends? Sons killing their mothers... their fathers?",
                        CategoryOverride = ModAPI.FindCategory("God of War"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/gow4/boy.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/gow4/boy.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;

                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow4/boy_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Bubbles";
                            }

                        foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow4/boy_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }
                            foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("FrontArm").Find("LowerArmFront"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow4/boy_lowerarm.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
                            }
                        }

                    }
                );
                ModAPI.Register(
                      new Modification()
                      {
                          OriginalItem = ModAPI.FindSpawnable("Crossbow"),
                          NameOverride = "[GoW4] Talon Bow -GoW",
                          DescriptionOverride = "Atreus wields a bow and, provided he isn't distracted, is a skilled archer. He's also proficient in using the bow as a blunt weapon, allowing him to trip or choke his adversary. His talon bow is also infused with some elemental abilities which augment his arrows, such as;",
                          CategoryOverride = ModAPI.FindCategory("God of War"),
                          ThumbnailOverride = ModAPI.LoadSprite("ic/gow4/bow.png", 22f),
                          AfterSpawn = (Instance) =>
                          {
                              Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("we/gow4/bow.png", 2.6f);
                                Instance.FixColliders();
                             
                          }
                      }
                  );
                  ModAPI.Register(
                    new Modification()
                    {
                        OriginalItem = ModAPI.FindSpawnable("Human"),
                        NameOverride = "[GoW4] Baldur -GoW",
                        DescriptionOverride = "Hahaha. And here I thought your kind were supposed to be so enlightened. So much better than us. So much smarter. And yet here you hide out in the woods--like a coward.",
                        CategoryOverride = ModAPI.FindCategory("God of War"),
                        ThumbnailOverride = ModAPI.LoadSprite("ic/gow4/baldur.png", 22f),
                        AfterSpawn = (Instance) =>
                        {
                            //load textures for each layer (see Human textures folder in this repository)
                            var skin = ModAPI.LoadTexture("ch/gow4/baldur.png");


                            //get person
                            var person = Instance.GetComponent<PersonBehaviour>();

                            //use the helper function to set each texture
                            //parameters are as follows: 
                            //  skin texture, flesh texture, bone texture, sprite scale
                            //you can pass "null" to fall back to the original texture
                            person.SetBodyTextures(skin, null, null, 1);

                            //change procedural damage colours if they interfere with your texture (rgb 0-255)
                            person.SetBruiseColor(86, 62, 130); //main bruise colour. purple-ish by default
                            person.SetSecondBruiseColor(154, 0, 7); //second bruise colour. red by default
                            person.SetThirdBruiseColor(207, 206, 120); // third bruise colour. light yellow by default
                            person.SetRottenColour(202, 199, 104); // rotten/zombie colour. light yellow/green by default
                            person.SetBloodColour(108, 0, 4); // blood colour. dark red by default. note that this does not change decal nor particle effect colours. it only affects the procedural blood color which may or may not be rendered
                            foreach (var body in person.Limbs)
                            {

                                body.BaseStrength *= 1f;
                                body.Health *= 2f;
                                body.BreakingThreshold *= 2f;

                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Body").Find("LowerBody"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow4/baldur_lowerbody.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            }

                        foreach (var body in person.Limbs)
                            {


                                var backpack = new GameObject("Backpack");
                                backpack.transform.SetParent(Instance.transform.Find("Head"));
                                backpack.transform.localPosition = new Vector3(0f, 0f);
                                backpack.transform.localScale = new Vector3(1f, 1f);
                                var backpackSprite = backpack.AddComponent<SpriteRenderer>();
                                backpackSprite.sprite = ModAPI.LoadSprite("ch/gow4/baldur_hair.png");
                                backpack.GetComponent<SpriteRenderer>().sortingLayerName = "Foreground";
                            } 
                        }

                    }
                );
            }
        }
    }
}